package formes;

import java.awt.geom.Point2D;

abstract class FormeAbstraite implements Forme {

	Point2D centreGravite;

	public FormeAbstraite(Point2D p) {
		centreGravite = (Point2D) p.clone();
	}

	/* (non-Javadoc)
	 * @see formes.Forme#centreGravite()
	 */
	@Override
	public Point2D centreGravite() {
		return (Point2D) centreGravite.clone();
	}

	/* (non-Javadoc)
	 * @see formes.Forme#perimetre()
	 */
	@Override
	public abstract double perimetre();

	/* (non-Javadoc)
	 * @see formes.Forme#surface()
	 */
	@Override
	public abstract double surface();

	/* (non-Javadoc)
	 * @see formes.Forme#placer(java.awt.geom.Point2D)
	 */
	@Override
	public void placer(Point2D nouveauCentreGravite) {
		centreGravite.setLocation(nouveauCentreGravite);
	}

	/* (non-Javadoc)
	 * @see formes.Forme#translater(double, double)
	 */
	@Override
	public void translater(double dx, double dy) {
		centreGravite.setLocation(centreGravite.getX() + dx, centreGravite.getY() + dy);
	}

	public String toString() {
		return getClass().getName() + " de centre (" + centreGravite.getX() + "," + centreGravite.getY() + ")";
	}
}